"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var http_1 = require('@angular/http');
var FluentService = (function () {
    function FluentService(http) {
        this.http = http;
    }
    FluentService.prototype.setBaseUrl = function (baseUrl) {
        if (baseUrl && baseUrl.substr(-1) !== '/') {
            baseUrl = baseUrl + '/';
        }
        this.baseUrl = baseUrl;
    };
    FluentService.prototype.getBaseUrl = function () {
        return this.baseUrl;
    };
    FluentService.prototype.getUrl = function (endpoint) {
        return this.baseUrl + endpoint;
    };
    FluentService.prototype.get = function (endpoint, options) {
        var url = this.getUrl(endpoint);
        return this.http.get(url, options);
    };
    FluentService.prototype.post = function (endpoint, body, options) {
        var url = this.getUrl(endpoint);
        return this.http.post(url, body, options);
    };
    FluentService.prototype.put = function (endpoint, body, options) {
        var url = this.getUrl(endpoint);
        return this.http.put(url, body, options);
    };
    FluentService.prototype.delete = function (endpoint, options) {
        var url = this.getUrl(endpoint);
        return this.http.delete(url, options);
    };
    FluentService.prototype.patch = function (endpoint, body, options) {
        var url = this.getUrl(endpoint);
        return this.http.patch(url, body, options);
    };
    FluentService.prototype.head = function (endpoint, options) {
        var url = this.getUrl(endpoint);
        return this.http.head(url, options);
    };
    FluentService = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [http_1.Http])
    ], FluentService);
    return FluentService;
}());
exports.FluentService = FluentService;
//# sourceMappingURL=fluent.service.js.map